/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the GatewayPatchData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GatewayPatchData{}

// GatewayPatchData struct for GatewayPatchData
type GatewayPatchData struct {
	AuthKey *string `json:"auth_key,omitempty"`
	AuthSecret *string `json:"auth_secret,omitempty"`
}

// NewGatewayPatchData instantiates a new GatewayPatchData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGatewayPatchData() *GatewayPatchData {
	this := GatewayPatchData{}
	return &this
}

// NewGatewayPatchDataWithDefaults instantiates a new GatewayPatchData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGatewayPatchDataWithDefaults() *GatewayPatchData {
	this := GatewayPatchData{}
	return &this
}

// GetAuthKey returns the AuthKey field value if set, zero value otherwise.
func (o *GatewayPatchData) GetAuthKey() string {
	if o == nil || IsNil(o.AuthKey) {
		var ret string
		return ret
	}
	return *o.AuthKey
}

// GetAuthKeyOk returns a tuple with the AuthKey field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GatewayPatchData) GetAuthKeyOk() (*string, bool) {
	if o == nil || IsNil(o.AuthKey) {
		return nil, false
	}
	return o.AuthKey, true
}

// HasAuthKey returns a boolean if a field has been set.
func (o *GatewayPatchData) HasAuthKey() bool {
	if o != nil && !IsNil(o.AuthKey) {
		return true
	}

	return false
}

// SetAuthKey gets a reference to the given string and assigns it to the AuthKey field.
func (o *GatewayPatchData) SetAuthKey(v string) {
	o.AuthKey = &v
}

// GetAuthSecret returns the AuthSecret field value if set, zero value otherwise.
func (o *GatewayPatchData) GetAuthSecret() string {
	if o == nil || IsNil(o.AuthSecret) {
		var ret string
		return ret
	}
	return *o.AuthSecret
}

// GetAuthSecretOk returns a tuple with the AuthSecret field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GatewayPatchData) GetAuthSecretOk() (*string, bool) {
	if o == nil || IsNil(o.AuthSecret) {
		return nil, false
	}
	return o.AuthSecret, true
}

// HasAuthSecret returns a boolean if a field has been set.
func (o *GatewayPatchData) HasAuthSecret() bool {
	if o != nil && !IsNil(o.AuthSecret) {
		return true
	}

	return false
}

// SetAuthSecret gets a reference to the given string and assigns it to the AuthSecret field.
func (o *GatewayPatchData) SetAuthSecret(v string) {
	o.AuthSecret = &v
}

func (o GatewayPatchData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GatewayPatchData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.AuthKey) {
		toSerialize["auth_key"] = o.AuthKey
	}
	if !IsNil(o.AuthSecret) {
		toSerialize["auth_secret"] = o.AuthSecret
	}
	return toSerialize, nil
}

type NullableGatewayPatchData struct {
	value *GatewayPatchData
	isSet bool
}

func (v NullableGatewayPatchData) Get() *GatewayPatchData {
	return v.value
}

func (v *NullableGatewayPatchData) Set(val *GatewayPatchData) {
	v.value = val
	v.isSet = true
}

func (v NullableGatewayPatchData) IsSet() bool {
	return v.isSet
}

func (v *NullableGatewayPatchData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGatewayPatchData(val *GatewayPatchData) *NullableGatewayPatchData {
	return &NullableGatewayPatchData{value: val, isSet: true}
}

func (v NullableGatewayPatchData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGatewayPatchData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


